;-------------------------------------------------;
; S u b r o u t i n e                             ;
; Version 2.0                                     ;
;                                                 ;
; Programmed by Geoff Lywood aka KrYpT            ;
; <glywood@yahoo.com>                             ;
; ICQ: 117312247                                  ;
;                                                 ;
; A lot of effort went into making this code,     ;
; so please don't redistribute it under any name  ;
; but mine. This source is provided purely for    ;
; informational purposes and I am not responsible ;
; for any damage that may result from use of it.  ;
;-------------------------------------------------;


;--> Equates and definitions

#define bcall(label) RST 28h \ .dw label

ppstart     =$965B
ppcurrent   =$965D
pplast      =$965F

op1         =$8478

badtype     =$2517
badver      =$258F
errgeneric  =$2599

_GetBaseVer =$4C6F
_RclAns     =$4AD7


;--> Header
	.org $9D93
	.db $BB,$6D
;--> Actual Code
start:
	bcall(_getbasever)	;absolutely MUST have v1.14 of TI-OS
	dec a
	jp nz,badver
	ld a,b
	cp 14
	jp nz,badver

	call stackname		;stacks the calling program name on FPS and current offset on OPS
	ld bc,$5FAF		;The following are the same pushes made by the TI-OS.
	call push_bc_ops	;I have no idea what they mean, only that they
	ld bc,$5A67		;are always the same. This permits returning properly.
	call push_bc_ops
	xor a
	call push_a_ops
	
	bcall(_rclans)		;put the label name on op1
	ld a,(op1)		;errorcheck variable type
	cp 4
	jp nz,badtype
	rst 10h			;get the string (findsym)
	ld a,(de)
	or a			;don't allow zero-length strings
	jp z,badtype
	ld (chars),a		;save number of chars
	inc de
	ld a,(de)
	or a
	jp nz,badtype		;don't allow 256+ character strings
	inc de
	ld (lblptr),de		;save where string is

	ld hl,(ppstart)
	dec hl
	dec hl
	ld c,(hl)
	inc hl
	ld b,(hl)		;get size to bc
	inc hl

loop:
	ld a,b
	or c
	jr z,badlabel		;make sure not at end of program
	ld a,$D6
	cpir			;find a label
	push bc
chars =$+1
	ld b,0			;check this many chars
lblptr =$+1
	ld de,0			;check this string
cploop:
	ld a,(de)
	cp (hl)
	jr nz,cont		;not the same, so find another label
	inc de
	inc hl			;move to next chars
	djnz cploop
	ld a,(hl)
	cp $3E
	jr z,cont		;must be a $3E or $3F after (colon or new line)
	cp $3F
cont:
	pop bc
	jr nz,loop
	ld (ppcurrent),hl	;save current location				************
	ret


push_bc_ops:
	call $2B41
	.dw $7489
	.db $78

push_a_ops:
	call $2B41
	.dw $74A2
	.db $78

stackname:
	call $2B41
	.dw $5AB3
	.db $78

badlabel:
	ld a,20			;label error (i wonder why there isn't a system one?)
	jp errgeneric
.end